#!/usr/bin/perl

# This script creates a basic config file that represents the tc setup.  This needs to be called each time the tc setup is changed.  The create config files are used in a lot of other scripts so be sure to execute this command each you change your tc setup.

BEGIN { push (@INC,'/qos/modules'); }

use Data::Dumper ;
use qos_config ;
use qos ;

undef $DEBUG ;

# Find all local interfaces
%nics = nics () ;

# Find the needed counters from all detected interfaces
foreach $interface ( keys(%nics) ) {
$interface = $nics {$interface} ;
undef $VAR1 ;
undef $childs ;
undef @class ;

# Query all classes for this interface
my @class = `$BIN/tc -s -d class show dev $interface` ; # Get all class info

# Process the classes we found
foreach $ele (@class) {
	chomp ($ele) ;
	# we are only intersted in the "htb" lines
	# the other lines are statsistics and we are not intersted in them (right now)
	if ( $ele =~ /htb/ ) {
		@temp = split(" ",$ele) ;
		$i = 0 ;
		foreach $temp (@temp) {
			$i ++ ;
			if ( $temp eq "htb" ) {
				$classid = $temp[$i] ; # after "htb" we find the classid
			} elsif ( $temp eq "parent" ) {
				$VAR1->{$classid}{parent} = $temp[$i] ;
				# Generate a list of all child classes
				$VAR1->{$temp[$i]}{childs} = $VAR1->{$temp[$i]}{childs} . " " . $classid . " " if ( $VAR1->{$temp[$i]}{childs} !~ / $classid / ) ;
			} elsif ( $temp eq "leaf" ) {
				$VAR1->{$classid}{leaf} = $temp[$i] ;
			} elsif ( $temp eq "root" ) {
				# If this is the root class, we have to add it to the "root" variable
				$VAR1->{root}{childs} = $VAR1->{root}{childs} . " " . $classid . " " if ( $VAR1->{root}{childs} !~ / $classid / ) ;
			} elsif ( $temp eq "prio" ) {
				$VAR1->{$classid}{prio} = $temp[$i] ;
			} elsif ( $temp eq "quantum" ) {
				$VAR1->{$classid}{quantum} = $temp[$i] ;
			} elsif ( $temp eq "rate" ) {
				$VAR1->{$classid}{rate} = check_speed ($temp[$i]) ;
			} elsif ( $temp eq "ceil" ) {
				$VAR1->{$classid}{ceil} = check_speed ($temp[$i]) ;
			} elsif ( $temp eq "burst" ) {
				$VAR1->{$classid}{burst} = $temp[$i] ;
			} elsif ( $temp eq "cburst" ) {
				$VAR1->{$classid}{cburst} = $temp[$i] ;
			}
		}
	}
}

my @qdics = `$BIN/tc -s -d qdisc show dev $interface` ; # Get all qdics info

foreach $ele (@qdics) {
	chomp ($ele) ;
	if ( $ele =~ /sfq/ ) {
		@temp = split(" ",$ele) ;
		$i = 0 ;
		foreach $temp (@temp) {
			$i ++ ;
			if ( $temp eq "sfq" ) {
				$qdisc = $temp[$i] ;
				# Store the type of attached qdisc
				$VAR1->{$qdisc}{type} = "sfq" ;
			} elsif ( $temp eq "quantum" ) {
				$VAR1->{$qdisc}{quantum} = $temp[$i] ;
			}
		}
	}
}

# Dump everytging to a file
open (FILE, ">$CONFIG/tc.$interface" ) || die "Can not open file\n" ;
print FILE Dumper ($VAR1) ;
print Dumper ($VAR1) if $DEBUG ;
close FILE ;

}
