#!/usr/bin/perl
#
# This script belongs in the cgi-bin dir of your web-server
# Version 0.1

# All ":" in the handles are replaced with _ because : is used within rrd
# So you will see a lot of replacing : with _ .

BEGIN { push (@INC,'/qos/modules'); }

use qos_config ;
use CGI qw (:standard) ;
use RRDs ;

$webcgi = url ; # Get our URL
$handle = param ('handle') or die "parameter : handle " ;

$type   = param('type') ;
$int    = param('int') ;
$graph  = param('graph') ;
$childs = param('childs') ;
@childs = split ("_",$childs) ;

@color = ("#00FF00","#0000FF","#FF0000","#FFFF00") ;
$date = localtime ;

# Check an/or create the needed directories
if (not -d $TMP) {
	mkdir $TMP,0755 ;
}
if (not -d "$TMP/images") {
	mkdir "$TMP/images",0755 ;
}
open (DEBUG,">>$TMP/debug") ;

# 4 type of graphs :
#   1. Last 48 hours
#   2. Last 12 days
#   3. Last 48 days
#   4. Last 2 years
#
@graphs = (1,2,3,4) ;
$start{1} = "e-48h";
$start{2} = "e-12d";
$start{3} = "e-48d";
$start{4} = "e-576d";

# What data is stored where
%config = (
	bytes => {
		rrd => ".1.rrd" ,
		data => "by",
	},
	packets => {
		rrd => ".1.rrd" ,
		data => "pa",
	},
	dropped => {
		rrd => ".1.rrd" ,
		data => "dr",
	},
	overlimits => {
		rrd => ".1.rrd" ,
		data => "ov",
	},
	lended => {
		rrd => ".2.rrd" ,
		data => "le",
	},
	borrowed => {
		rrd => ".2.rrd" ,
		data => "bo",
	},
	giants => {
		rrd => ".2.rrd" ,
		data => "gi",
	},
	injects => {
		rrd => ".2.rrd" ,
		data => "in",
	},
	tokens => {
		rrd => ".3.rrd" ,
		data => "to",
	},
	ctokens => {
		rrd => ".3.rrd" ,
		data => "ct",
	},
) ;

# If we have to draw a graph, make one :
if($graph) {
	print header (-type=>'image/png',-expires=>'+5m');

	# We store the image in a temp-file
	$graph_png = $TMP . "/images/$int.$handle.$type.$graph.$childs.png" ;

	# Create a png image
	@option = ("-s","$start{$graph}","-a","PNG","--lazy") ;

	# If we have to draw the packet size, we need to do some calculations
	if ( $type eq "packet_size") {
		$color=0;
		$handle2 = $handle ;
		$handle =~ s/:/\\:/g ; # : needs to be written as \\:
		$handle2 =~ s/:/_/g ; # replace : by _ 

		$rrd = $RRDS . "/" . $int . "." . $handle2 . ".1.rrd" ;
		print DEBUG "rrd : $rrd\n" ;

		push (@option,"DEF:b_temp=$rrd:by:AVERAGE") ;
		push (@option,"DEF:p_temp=$rrd:pa:AVERAGE") ;
		push (@option,"CDEF:temp=b_temp,p_temp,/") ;
		push (@option,"AREA:temp$color[$color]:$handle:") ;
		push (@option,"GPRINT:temp:LAST:Current \\: %5.1lf $type\\n") ;

		$color ++ ;
		foreach $child (@childs) {
			$child = $child ;
			$child2 =~ s/:/_/g ;
			$child =~ s/:/\\:/g ;
			$rrd = $RRDS . "/" . $int . "." . $child2 . ".1.rrd" ;
			push (@option,"DEF:b_$child2=$rrd:by:AVERAGE") ;
			push (@option,"DEF:p_$chile2=$rrd:pa:AVERAGE") ;
			push (@option,"CDEF:size_$chile2=b_$child2,p_$child2,/") ;
			push (@option,"AREA:size_$child2$color[$color]:$child:") ;
			push (@option,"GPRINT:size_$child2:LAST:Current \\: %5.1lf $type\\n") ;
			$color ++ ;
		}
	} elsif ( $type eq "procent") {
		push (@option,"-l","0","-u","100","-r") ;
		@childs_backup = @childs ;
		$first = shift @childs ;
		$first =~ s/:/_/g ;

		$rrd = $RRDS . "/" . $int . "." . $first . ".1.rrd" ;
		push (@option,"DEF:tot_0=$rrd:by:AVERAGE") ;
#push (@option,"GPRINT:tot_0:LAST:TOT \\: %5.1lf \\n") ;
		$color=0;
		foreach $child (@childs) {
			$child2 = $child ;
			$color_old = $color ;
			$color ++ ;
			$child2 =~ s/:/_/g ;
			$child =~ s/:/\\:/g ;
			$rrd = $RRDS . "/" . $int . "." . $child2 . ".1.rrd" ;
			push (@option,"DEF:b_$child2=$rrd:by:AVERAGE") ;
#push (@option,"GPRINT:b_$child2:LAST:Waarde $child2 \\: %5.1lf \\n") ;
			push (@option,"CDEF:tot_$color=b_$child2,tot_$color_old,+") ;
#push (@option,"GPRINT:tot_$color:LAST:TOT $child2  \\: %5.1lf \\n") ;
		}

		$handle2 = $handle ;
		$handle =~ s/:/\\:/g ;
		$handle2 =~ s/:/_/g ;
		$rrd = $RRDS . "/" . $int . "." . $handle2 . ".1.rrd" ;
		push (@option,"DEF:total=$rrd:by:AVERAGE") ;
#push (@option,"GPRINT:tot_$color:LAST:total $total \\: %5.1lf \\n") ;
		push (@option,"CDEF:parent=total,tot_$color,-") ;
#push (@option,"GPRINT:parent:LAST:TOT \\: %5.1lf \\n") ;

		@childs = @childs_backup ;
		$first = shift @childs ;
		$first =~ s/:/\\:/g ;
		$color1=0;
		push (@option,"CDEF:total_pct=parent,total,/,100,*") ;
		push (@option,"AREA:total_pct$color[$color1]:$handle:") ;
		push (@option,"GPRINT:total_pct:LAST:Current \\: %5.1lf $type\\n") ;

		$color1 ++ ;
		push (@option,"CDEF:tot_0_pct=tot_0,total,/,100,*") ;
		push (@option,"STACK:tot_0_pct$color[$color1]:$first:") ;
		push (@option,"GPRINT:tot_0_pct:LAST:Child  \\: %5.1lf $type\\n") ;
		foreach $child (@childs) {
			$child2 = $child ;
			$child2 =~ s/:/_/g ;
			$color1 ++ ;
			$child =~ s/:/\\:/g ;
			push (@option,"CDEF:tot_pct_$child2=b_$child2,total,/,100,*") ;
			push (@option,"STACK:tot_pct_$child2$color[$color1]:$child:") ;
			push (@option,"GPRINT:tot_pct_$child2:LAST:Child  \\: %5.1lf $type\\n") ;
		}

	} else {
		$color=0;
		$handle2 = $handle ;
		$handle2 =~ s/:/_/g ;

		$rrd = $RRDS . "/" . $int . "." . $handle2 . $config{$type}{rrd} ;
		$handle =~ s/:/\\:/g ;

		if ( @childs ) {
			push (@option,"DEF:handle=$rrd:$config{$type}{data}:AVERAGE") ;
			push (@option,"LINE1:handle$color[$color]:$handle:") ;
			push (@option,"GPRINT:handle:LAST:Current \\: %5.1lf $type/s\\n") ;
		} else {
			# Show the current value
			push (@option,"DEF:handle=$rrd:$config{$type}{data}:AVERAGE") ;
			push (@option,"AREA:handle$color[$color]:$handle:") ;
			push (@option,"GPRINT:handle:LAST:Current \\: %5.1lf $type/s\\n") ;
			$color ++ ;
			# Show the maximum value
			push (@option,"DEF:handle_max=$rrd:$config{$type}{data}:MAX") ;
			push (@option,"LINE1:handle_max$color[$color]:$handle:") ;
			push (@option,"GPRINT:handle_max:MAX:Max     \\: %5.1lf $type/s\\n") ;
			$color ++ ;
			# Show the minimum value
			push (@option,"DEF:handle_min=$rrd:$config{$type}{data}:MIN") ;
			push (@option,"LINE1:handle_min$color[$color]:$handle:") ;
			push (@option,"GPRINT:handle_min:MIN:Min     \\: %5.1lf $type/s\\n") ;
		}

		$color ++ ;
		foreach $child (@childs) {
			$child2 = $child ;
			$child2 =~ s/:/_/g ;
			$rrd = $RRDS . "/" . $int . "." . $child2 . $config{$type}{rrd} ;
			$child =~ s/:/\\:/g ;
			push (@option,"DEF:$config{$type}{data}$child2=$rrd:$config{$type}{data}:AVERAGE") ;
			if ( $color eq "1" ) {
				push (@option,"AREA:$config{$type}{data}$child2$color[$color]:$child:") ;
			} else {
				push (@option,"STACK:$config{$type}{data}$child2$color[$color]:$child:") ;
			}
			push (@option,"GPRINT:$config{$type}{data}$child2:LAST:Current \\: %5.1lf $type/s\\n") ;
			$color ++ ;
		}
	}

	push (@option,"COMMENT:$date") ;
	RRDs::graph($graph_png, @option ) ;
	my ($err) = RRDs::error;
	die $err if $err;

	open ( GRAPH, "<$graph_png" ) ;
	binmode(GRAPH);
	while ($len = read(GRAPH,$bits,8192)) {
		$pic .= $bits;
	}
	print $pic;

# If we have a type, show the 4 possible graphs :
} elsif ($type) {
	print header () ;
	print start_html (-style=>{'code'=>"$CSS"}) ;
	#print qq{<html><head>
#<META HTTP-EQUIV="REFRESH" CONTENT="300">
#</head><body>
#} ;

#<META HTTP-EQUIV="EXPIRES" CONTENT="Sat, 01 Jan 2001 00:00:00 GMT">
	$handle2 = $handle ;
	$handle2 =~ s/_/:/g ;
	if ( @childs ) {
		print qq{<H1>Handle $handle on interface $int with childs @childs</H1>}; 
	} else {
		print qq{<H1>Handle $handle on interface $int</H1>}; 
	}
	foreach my $graph (@graphs) {
		print qq{<P><IMG SRC=$webcgi?handle=$handle&type=$type&int=$int&graph=$graph&childs=$child BORDER=0>};
	}
	print qq{</BODY></HTML>} ;

# Show all the possible types of graph we can draw :
} else {
	print header ;
	print qq{<html><head>
<META HTTP-EQUIV="REFRESH" CONTENT="300">
<link rel="stylesheet" type="text/css" href="/qos/qos.css" />
</head><body>
} ;
#<META HTTP-EQUIV="EXPIRES" CONTENT="Sat, 01 Jan 2001 00:00:00 GMT">
	$handle2 = $handle ;
	$handle2 =~ s/_/:/g ;
	if ( @childs ) {
		print qq{<H1>Handle $handle on interface $int with childs @childs</H1>}; 
	} else {
		print qq{<H1>Handle $handle on interface $int</H1>} ;
	}

	($major,$minor) = split ":", $handle ;
        print qq{
<applet codebase="$WWW_HOST$WWW_BASE/graph/" code="tcgraph.class" width=300 height=100>
<param name=dataSource value="$WWW_HOST$CGI_BASE/get_tc_counter.pl?device=$int&major=$major&minor=$minor">
<param name=speed value="3">
</applet>};
	if ( $child != "" ) {
		print qq{<P><A HREF=$webcgi?handle=$handle&type=procent&int=$int&childs=$child><IMG SRC=$webcgi?handle=$handle&type=procent&int=$int&graph=1&childs=$child BORDER=0></A>} ;
	}
	print qq{
<P><A HREF=$webcgi?handle=$handle&type=bytes&int=$int&childs=$child>
  <IMG SRC=$webcgi?handle=$handle&type=bytes&int=$int&graph=1&childs=$child BORDER=0></A>
<P><A HREF=$webcgi?handle=$handle&type=packets&int=$int&childs=$child>
  <IMG SRC=$webcgi?handle=$handle&type=packets&int=$int&graph=1&childs=$child BORDER=0></A>
<P><A HREF=$webcgi?handle=$handle&type=packet_size&int=$int&childs=$child>
  <IMG SRC=$webcgi?handle=$handle&type=packet_size&int=$int&graph=1&childs=$child BORDER=0></A>
} ;
	foreach $ele (keys(%config )) {
		print "<br><A HREF=$webcgi?handle=$handle&type=$ele&int=$int&childs=$child>$ele</A>" ;
	}
	print qq{</BODY></HTML>} ;
}

