#!/usr/bin/perl

# This config file is used in almost each script.  You can change some 
# options, but most of them are already ok.

# Where is the software installed.  You better installed it on /qos
# because this path is hard coded in some scripts.
$BASE     ="/qos" ;

# Directory must exists ans writable by the web-server id !!!!!
$CONFIG   = "$BASE/config" ;

# Uncomment next line if you don't want to see the config link in the left menu
$SHOW_CONFIG = "yes" ;

# Some files in this directory are used with the id of the web-server.
# So you need to set the sticky-bit to execute them
$BIN      = "$BASE/bin" ;

# Some options for the web-server
$WWW_BASE ="/qos" ;
$CGI_BASE ="/cgi-bin/qos" ;
$WWW_HOST ="http://qos.dyndns.org:3389" ;

# page with an overview of available graphs
$html_output = "$BASE/www/snmp.html" ;

# Place where databases are stored.  Make sure your webserver has read access.
$RRDS = "$BASE/rrds" ;

# IF you get the data remotly from an other route, you can set these variable.
# You also need to instal some extra scripts on that router.
# These options are used by the get_snmp.pl script.  If your router
# and server are the same machine, you don't have to set these options.
$host = "geuze" ;
$community = "public" ;

# OID to query on the snmp-server
# The corresponding entry in my snmpd.conf :
# pass .1.3.6.1.4.1.2021.255 /home/firewall/snmp/snmp.pl
$oid = ".1.3.6.1.4.1.2021.255" ;

# place to store the graphs, the web-server needs write access
$TMP = "$BASE/tmp" ;

$TC="$BIN/tc" ;
$IP="$BIN/ip" ;

#$DISABLE_DOCUM="yes" ;


$CSS=qq{BODY {
   background-color: #e0e0e0;
   text: #FFFFFF;
   margin-top: 10 ;
   font-size: 0.9pc ;
}

A:link {
   color: #3333FF;
   /*color: #3333FF;
   /*font-weight: bold ;*/
}
A:hover {
   color: #0000FF;
   /*font-weight: bold ;*/
}
A:active {
   color: #0000FF;
   /*font-weight: bold ;*/
}
A:visited {
   color: #3333FF;
   /*font-weight: bold ;*/
}

H1 { color: #BB0000 ; }
H3 { color: #00AA00 ; }
H2 { color: #009900 ; }

pre {
   white-space: pre ;
   font-family: monospace ;
   font-size: 0.7pc ;
   display: block ;
   padding: 0.3em ;
   border: 1px ;
   background:#DDDDCC ;
 }

TR {
   white-space: nowrap;
   font-size: 0.9pc ;
   background-color: #cccc99;
   color: #000000;
}

TH {
   white-space: nowrap;
   font-size: 0.9pc ;
   white-space: nowrap;
   background-color: #cccc99;
   color: #000000;
}

TD.png {
   padding-right: 0em ;
   padding-left: 0em ;
   text-align: left ;
}

TD.left {
   padding-right: 0em ;
   padding-left: 0.4em ;
   text-align: left ;
}

TD {
   white-space: nowrap;
   font-size: 0.9pc ;
   background-color: #f0f0e0;
   color: #000000;
   padding-right: 0.3em ;
   padding-left: 0.3em ;
   text-align: center ;
}
};

return 1 ;
