//******************************************************************************
// tcgraph_ok.java:	Applet
//
// Version: 1.02
//
// Changes:
//
//  1.02: replaced the 'counter" parm with the "dataSource" parm
//        made the entire cgi URL the parm so others can easily use
//         their own cgi for data retrieval
//
//  1.01: fixed bug in scale adjustments
//
//******************************************************************************
// This java demo is Copyright, 1997 by hav.Software and Horace A. Vallas, Jr.
// All rights reserved.
//
// You may use this code for non-commercial use; however,
// NO WARRANTY IS MADE in relation to this code or it's use and 
// you assume full responsibility for it's use etc.etc.etc.
//
//******************************************************************************

import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class tcgraph_ok extends Applet implements Runnable {

	Thread	 m_VisitorCounter = null;

	private  String dataSource;	 // the cgi URL
	private  int m_speed = 5;	 // seconds between counter data retrievals	 (parameter)

	private  Image offImage;		 // off-screen display for all
	private  Graphics offGraphic;	 // zoomed displays

	private  int chartWidth;	   // width of chart (grid) section in pixels (computed)
	private  int chartHeight;	   // height of the chart (grid) section  (parameter)
	private  int xStep;			   // pixel length of line segments when plotting the data (parameter)
	private  int ySpace;		   // space above/below the max/min plotted values (parameter)

	private  int appWidth;		   // applet widow width (computed)
	private  int appHeight;		   // applet window height (computed)

	private  String theCount = ""; // the data vallues read from the source on a given execution cycle
	private  int theCountint;
	private  int theCountint2;
	private  int cntWidth;		   // width of the y-axis labels (set now for 7 char max)
	private  int previousData;
	private final  int charSize = 12;	  // font info
	private final  int halfCharSize = 6;
	private  Dimension chartLLC;		// position of the Lower Left Cornet of the grid
	private  Dimension chartTLC;		// Top Left Corner position
	private  Dimension chartLRC;		// Lower Right Corner position
	private  Dimension chartTRC;		// Top Right Corner position
	private  Dimension maxLabelPos;		// position of the max Y scals lebel
	private  Dimension midLabelPos;		// position id the mid Y scale label
 	private  Dimension minLabelPos;		// position of the min Y scale label
	private  Dimension cntLabelPos;		// position of the current count (X axix) label


	private  int[] theData;		 // the displayed data (a circular buffer
	private  int bufSize = 1;	 // number of elements in theData buffer
	private  int inData;		// index of the position of the next input element in theData
	private  int outData;		// index of the first output position in theData
	private  boolean bufFull;

	private  int chartMaxY;		// Max Y value (in data Units)
	private  int chartMinY;		// Min Y value (in data units)


	private  Font font1;		  // the font to be used
	private  FontMetrics fontM;


    // Parameter names.  To change a name of a parameter, you need only make
	// a single change.  Simply modify the value of the parameter string below.
    //--------------------------------------------------------------------------
	private final String PARAM_dataSource = "dataSource";
	private final String PARAM_bufSize = "bufSize";
	private final String PARAM_chartHeight = "chartHeight";
	private final String PARAM_xStep = "xStep";
	private final String PARAM_ySpace = "ySpace";
	private final String PARAM_speed = "speed";

	public tcgraph_ok() { }


//=============================================================================================	
	public void init()
	{
		String param;

		//=================================
		param = getParameter(PARAM_dataSource);
		if (param != null)
			dataSource = param;

		//=================================
		param = getParameter(PARAM_speed);
		if (param != null)
			m_speed = Integer.parseInt(param);


		//=================================
		param = getParameter(PARAM_bufSize);
		if (param != null) {
			try {
				bufSize = Integer.parseInt(param);
			} catch (NumberFormatException e){
				bufSize = 1;
			}
		} else {
			bufSize = 1;
		}

		//=================================
		param = getParameter(PARAM_chartHeight);
		if (param != null) {
			try {
				chartHeight = Integer.parseInt(param);
			} catch (NumberFormatException e){
				chartHeight = 0;
			}
		} else {
			chartHeight = 0;
		}

 		//=================================
		param = getParameter(PARAM_xStep);
		if (param != null) {
			try {
				xStep = Integer.parseInt(param);
			} catch (NumberFormatException e){
				xStep = 2;
			}
		} else {
			xStep = 2;
		}

 		//=================================
		param = getParameter(PARAM_ySpace);
		if (param != null) {
			try {
				ySpace = Integer.parseInt(param);
			} catch (NumberFormatException e){
				ySpace = 10;
			}
		} else {
			xStep = 10;
		}
		chartMinY = ySpace;
		chartMaxY = ySpace * 4;

 		//=================================
		font1 = new Font("Arial", Font.BOLD, charSize);
		setFont(font1);
		fontM = getFontMetrics(font1);
		cntWidth = fontM.stringWidth("MMMMMMM");

 		//=================================
		Dimension dim = size();
		appWidth = dim.width;
		appHeight = dim.height;

		if (chartHeight > 0) {
			chartWidth = (bufSize * xStep);

			chartLLC = new Dimension(cntWidth + 5, chartHeight + halfCharSize);
 			chartTLC = new Dimension(chartLLC.width, halfCharSize);
			chartLRC = new Dimension(chartWidth + chartLLC.width, chartLLC.height);
			chartTRC = new Dimension(chartLRC.width, chartTLC.height);
			maxLabelPos = new Dimension(0, charSize);
			midLabelPos =  new Dimension(0, (chartLLC.height + chartTLC.height) / 2 + halfCharSize);
			minLabelPos = new Dimension(0, chartLLC.height + halfCharSize);
			cntLabelPos = new Dimension(chartLRC.width - (cntWidth / 2), chartLLC.height + 5 + charSize);

		} else {
			chartWidth = 0;
			appHeight = charSize;
		}
 		//=================================
		theData = new int[bufSize];
		for (int i = 0; i < bufSize  ; i++)
			theData[i] = ySpace * 2;
		inData = 0;
		outData = 0;
		bufFull = false;
 		//=================================
		resize(appWidth, appHeight);

	}
	
	public void paint(Graphics g) {	
		g.drawImage(offImage, 0, 0, null);
	}

	public final synchronized void  update(Graphics g)   {                     
		// override the default update method in order to
		// use double buffering of the grapgic and avoid
		// watching the screens be drawn
		
		int i, j;
		int xFrom, xTo, yFrom, yTo;

		if (offImage == null) {
			offImage = createImage(appWidth, appHeight);
			offGraphic = offImage.getGraphics();
			offGraphic.setFont(font1);
		}

		offGraphic.setColor(Color.white);
		offGraphic.fillRect(0,0,appWidth, appHeight);
		
		// get the current counter value
		try {
			if ( inData == 0 ) {
				URL theURL = new URL(dataSource);
				DataInputStream dis = new DataInputStream(theURL.openStream());
				previousData = Integer.parseInt(dis.readLine());
				dis.close();
				//Thread.sleep(m_speed * 1000);
			}
			URL theURL = new URL(dataSource);
			DataInputStream dis = new DataInputStream(theURL.openStream());
			theCount = dis.readLine();
			theCountint = ( Integer.parseInt(theCount) - previousData ) / m_speed ;
			theCountint2 = ( Integer.parseInt(theCount) - previousData ) ;
			previousData = Integer.parseInt(theCount);
			dis.close();
		} catch (MalformedURLException me) {
			System.out.println("MalformedURLException: " + me);
		} catch (IOException ioe) {
			System.out.println("IOException: " + ioe);
		}
		
		if (chartHeight > 0) {
			// get the new data value
			try {
				theData[inData] = theCountint;

			} catch (NumberFormatException e){
				theData[inData] = ySpace;
			}		

			inData = (inData + 1) % bufSize;
			if (inData == bufSize - 1) 
				bufFull = true;

			// adjust the min/max Y values and scale values
			// if needed to keep a good data resolution visible

			chartMaxY = ((getMaxData() / ySpace) * ySpace) + ySpace;
			chartMinY = ((getMinData() / ySpace) * ySpace);
			if (chartMaxY == chartMinY)
				chartMinY -= ySpace / 2;

			double yM = (((double) chartHeight) /
						(double)(chartMaxY - chartMinY));
			double yA = - ((yM * (double)chartMaxY) - (double)chartHeight);

			// now draw the labels

			offGraphic.setColor(Color.black);
			offGraphic.drawString(""+chartMaxY, cntWidth - fontM.stringWidth("" + chartMaxY), maxLabelPos.height);
			offGraphic.drawString(""+ (chartMaxY - ((chartMaxY - chartMinY)/ 2)), cntWidth - fontM.stringWidth("" + (chartMaxY / 2)), midLabelPos.height);
 			offGraphic.drawString(""+chartMinY, cntWidth - fontM.stringWidth("" + chartMinY), minLabelPos.height );

			// now draw the grid
			offGraphic.setColor(Color.lightGray);
			offGraphic.drawLine(chartTLC.width - 3, chartTLC.height, chartTRC.width, chartTRC.height);
			offGraphic.drawLine(chartTLC.width - 3, midLabelPos.height - halfCharSize, chartTRC.width, midLabelPos.height - halfCharSize);
			offGraphic.drawLine(chartTLC.width - 3, chartLLC.height, chartTRC.width, chartLLC.height);
			for (i = chartTLC.width; i <= chartTRC.width; i += xStep*2) 
				offGraphic.drawLine(i, chartTLC.height, i, chartLLC.height + 3);

			// now Draw the Data
			offGraphic.setColor(Color.blue);

			// the data trace
			xFrom = cntWidth + 5;
			xTo = xFrom + xStep;

			for (i = outData, j = ((i + 1) % bufSize), yFrom = chartLLC.height - (int)(((double)theData[outData]) * yM + yA);
					j != inData;
					i = ((i + 1) % bufSize), j = (j + 1) % bufSize) {
				yTo = chartLLC.height - (int)(((double)theData[j]) * yM + yA);
				offGraphic.drawLine(xFrom, yFrom, xTo, yTo);
				offGraphic.drawLine(xFrom, yFrom+1, xTo, yTo+1);
				yFrom = yTo;
				xFrom = xTo;
				xTo += xStep;
			}
			if (bufFull)
				outData = (outData + 1) % bufSize;
			
			// finally, draw the cur data vert line and the count value
			xTo -= xStep;
			offGraphic.setColor(Color.black);
			theCount = Integer.toString (theCountint);
			offGraphic.drawString(theCount, xTo - (fontM.stringWidth(theCount) / 2), cntLabelPos.height);
			offGraphic.setColor(Color.red);
			offGraphic.drawLine(xTo, chartTLC.height, xTo, chartLLC.height + 3);
			
		} else {
			// just display the counter value
			offGraphic.setColor(Color.black);
			theCount = Integer.toString (theCountint2);
			offGraphic.drawString(theCount, 0, appHeight);
		}
		paint(g);
    }

	
	private int getMaxData() {
		int max = Integer.MIN_VALUE;
		int i,j;
		if (!bufFull && inData == 1)
			return theData[outData] + ySpace;
		for (i = outData; i != inData; i = (i + 1) % bufSize)
		if (max < theData[i])
			max = theData[i];
		return  max;
	}

	private int getMinData() {
		int min = Integer.MAX_VALUE;
		int i,j;
		if (!bufFull && inData == 1)
			return theData[outData] - ySpace;;
		for (i = outData; i != inData; i = (i + 1) % bufSize)
		if (min > theData[i])
			min = theData[i];
		return min;
	}

	public void destroy() { }

	public String getAppletInfo() {
		return "Name: Named Counter Java Display - 1.01\r\n" +
				"Copyright, 1997 by hav.Software and Horace A. Vallas, Jr.\r\n" +
				"All rights reserved.\r\n" +
				"\r\n" +
				"Changes:\r\n" + 
				"1.02: replaced parameter counter with dataSource and made entire cgi url a parm" +
				"1.01: fixed bug in scale adjustments\r\n" +
				"\r\n" +
				"Author: Horace Vallas\r\n" +
				"hav@hav.com\r\n" + 
				"http://www.hav.com/" +
				"\r\n" +
				"You may use this code for non-commercial use; however,\r\n" +
				"NO WARRANTY IS MADE in relation to this code or it's use and \r\n" +
				"you assume full responsibility for it's use etc.etc.etc.\r\n";
	}

	public String[][] getParameterInfo() {
		String[][] info = {
			{PARAM_dataSource, "String", "URL of the CGI or other data source for displayed data"},
			{PARAM_bufSize, "String", "size of the data buffer"},
			{PARAM_chartHeight, "String", "height in pixels of the chart section"},
			{PARAM_xStep, "String", "pixels per data element when plotted"},
			{PARAM_ySpace, "String", "space above/below the max/min data values"},
			{PARAM_speed, "String", "number of seconds between counter data retrievals"},
		};
		return info;		
	}

	public void start() {
		if (m_VisitorCounter == null) {
			m_VisitorCounter = new Thread(this);
			m_VisitorCounter.start();
		}
	}
	
	public void stop() {
		if (m_VisitorCounter != null) {
			m_VisitorCounter.stop();
			m_VisitorCounter = null;
		}
	}

	public void run() {
		while (true) {
			try {
				repaint();
				Thread.sleep(m_speed * 1000);
			}
			catch (InterruptedException e) {
				stop();
			}
		}
	}
}
